Package org.apache.commons.collections4.iterators

# Class AbstractListIteratorDecorator<E>

java.lang.Object
org.apache.commons.collections4.iterators.AbstractListIteratorDecorator<E>

Type Parameters:
  `E` - the type of elements in this iterator.

All Implemented Interfaces:
  `Iterator<E>`, `ListIterator<E>`

Direct Known Subclasses:
  `PredicatedList.PredicatedListIterator`, `TransformedList.TransformedListIterator`

public class AbstractListIteratorDecorator<E> extends Object implements ListIterator<E>
Provides basic behavior for decorating a list iterator with extra functionality.

All methods are forwarded to the decorated list iterator.

Since:
  3.0

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AbstractListIteratorDecorator(ListIterator<E> iterator)`
  Constructor that decorates the specified iterator.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `add(E obj)`
  `protected ListIterator<E>`
  `getListIterator()`
  Gets the iterator being decorated.
  `boolean`
  `hasNext()`
  `boolean`
  `hasPrevious()`
  `E`
  `next()`
  `int`
  `nextIndex()`
  `E`
  `previous()`
  `int`
  `previousIndex()`
  `void`
  `remove()`
  `void`
  `set(E obj)`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface java.util.Iterator

  `forEachRemaining`

- ## Constructor Details

  - ### AbstractListIteratorDecorator

    public AbstractListIteratorDecorator(ListIterator<E> iterator)
    Constructor that decorates the specified iterator.
    Parameters:
      `iterator` - the iterator to decorate, must not be null
    Throws:
      `NullPointerException` - if the iterator is null

- ## Method Details

  - ### add

    public void add(E obj)
    Specified by:
      `add` in interface `ListIterator<E>`

  - ### getListIterator

    protected ListIterator<E> getListIterator()
    Gets the iterator being decorated.
    Returns:
      the decorated iterator

  - ### hasNext

    public boolean hasNext()
    Specified by:
      `hasNext` in interface `Iterator<E>`
    Specified by:
      `hasNext` in interface `ListIterator<E>`

  - ### hasPrevious

    public boolean hasPrevious()
    Specified by:
      `hasPrevious` in interface `ListIterator<E>`

  - ### next

    public E next()
    Specified by:
      `next` in interface `Iterator<E>`
    Specified by:
      `next` in interface `ListIterator<E>`

  - ### nextIndex

    public int nextIndex()
    Specified by:
      `nextIndex` in interface `ListIterator<E>`

  - ### previous

    public E previous()
    Specified by:
      `previous` in interface `ListIterator<E>`

  - ### previousIndex

    public int previousIndex()
    Specified by:
      `previousIndex` in interface `ListIterator<E>`

  - ### remove

    public void remove()
    Specified by:
      `remove` in interface `Iterator<E>`
    Specified by:
      `remove` in interface `ListIterator<E>`

  - ### set

    public void set(E obj)
    Specified by:
      `set` in interface `ListIterator<E>`